<?php
class acp_quiz
{
   var $u_action;
   var $new_config;
   function main($id, $mode)
   {
      global $db, $user, $auth, $template;
      global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		include_once($phpbb_root_path . 'includes/functions_quiz.' . $phpEx);
		$user->add_lang('mods/quiz');

		switch($mode)
		{
		case 'index':

			$sub_get = request_var('sub', '');

			if( $sub_get == 'quiz_category' )
			{
				$category_id = request_var('c', 0);

				if( request_var('type', '') == 'submit' )
				{
					$new_category_name = utf8_normalize_nfc( request_var('catname', '') );
					$new_category_desc = utf8_normalize_nfc( request_var('catdesc', '') );

						if( isset($category_id) )
						{
							if( request_var('type', '') == 'submit' )
							{
								$new_category_name = utf8_normalize_nfc( request_var('catname', '', true) );
								$new_category_desc = utf8_normalize_nfc( request_var('catdesc', '', true) );
		
								$db->sql_query("UPDATE " . QUIZ_CATEGORY_TABLE . "
												SET quiz_category_name = '" . $db->sql_escape($new_category_name) . "',
												quiz_category_description = '" . $db->sql_escape($new_category_desc) . "'
												WHERE quiz_category_id = $category_id");
		
								trigger_error($user->lang['QUIZ_CATEGORY_EDITED_SUCESSFULLY'] . adm_back_link($this->u_action));
							}
						}
				}

	            $this->page_title = 'ACP_QUIZ_CATEGORY';
	            $this->tpl_name = 'acp_quiz_categories';
			
				if( isset($category_id) )
				{
					$sql = "SELECT *
							FROM " . QUIZ_CATEGORY_TABLE . "
							WHERE quiz_category_id = " . $category_id;
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
	
					$template->assign_vars( array(
					'U_NEW'	=> false,
					'U_ACTION'	=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&sub=quiz_category&c=' . $category_id . '&type=submit'),
					'U_CATEGORY_NAME' => $row['quiz_category_name'],
					'U_CATEGORY_DESC' => $row['quiz_category_description'],
					));
				}
			}

			else if( $sub_get == 'quiz_category_delete' )
			{
				$category_id = request_var('c', 0);

				// no quizzes get deleted
				// the purpose of deleting a category is to simply remove
				// the category, with all quizzes being moved elsewhere

					if( request_var('type', '') == 'submit' )
					{
						$selected_new_category = request_var('select_category', 0); // the category to move it INTO

						if( $selected_new_category == $category_id || $selected_new_category == 'undefined' )
						{
							trigger_error($user->lang['QUIZ_CANNOT_DELETE_CATEGORY'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$move_sql = 'UPDATE ' . QUIZ_TABLE . '
										SET quiz_category = ' . $selected_new_category . '
										WHERE quiz_category = ' . $category_id;
						
						$delete_sql = 'DELETE FROM ' . QUIZ_CATEGORY_TABLE . '
										WHERE quiz_category_id = ' . $category_id;

						$db->sql_query($move_sql);
						$db->sql_query($delete_sql);

						trigger_error($user->lang['QUIZ_CATEGORY_DELETED_SUCCESSFULLY'] . adm_back_link($this->u_action));
					}
				
				$category_list = quiz_category_list($category_id);

	            $this->page_title = 'ACP_DELETE_QUIZ_CATEGORY';
	            $this->tpl_name = 'acp_quiz_categories_delete';
	
				$template->assign_vars( array(
				'U_ACTION'	=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&sub=quiz_category_delete&c=' . $category_id . '&type=submit'),
				'U_CATEGORY_LIST' => $category_list,
				));
			}

			else if( $sub_get == 'new_category' )
			{
				if( request_var('type', '') == 'submit' )
				{
					$new_category_name = utf8_normalize_nfc( request_var('catname', '', true) );
					$new_category_desc = utf8_normalize_nfc( request_var('catdesc', '', true) );

					$category_array = array(
  						'quiz_category_name'			=> $new_category_name,
						'quiz_category_description'		=> $new_category_desc,
					);

					$db->sql_query('INSERT INTO ' . QUIZ_CATEGORY_TABLE . '
								   ' . $db->sql_build_array('INSERT', $category_array));

					trigger_error($user->lang['QUIZ_CATEGORY_ADDED_SUCESSFULLY'] . adm_back_link($this->u_action));
				}

	            $this->page_title = 'ACP_QUIZ_CATEGORY';
	            $this->tpl_name = 'acp_quiz_categories';
	
				$template->assign_vars( array(
				'U_NEW' => true,
				'U_ACTION'	=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&sub=new_category&type=submit'),
				'U_CATEGORY_NAME' => '',
				'U_CATEGORY_DESC' => '',
				));
			}

			else
			{
				if( request_var('type', '') == 'submit' )
				{
					// Error checking, can't trust that user data
					// Make sure minimum # of questions is lower than the max
					if( request_var('submit_min', 0) > request_var('submit_max', 0) )
					{
						trigger_error($user->lang['QUIZ_CANNOT_MIN_MAX_SWITCH'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					// Have to be at least 2 multiple choices
					if( request_var('submit_max_multiple_choice', 0) < 2 )
					{
						trigger_error($user->lang['QUIZ_CANNOT_LOW_MAX'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					set_config('quiz_submit_min', request_var('submit_min', 0));
					set_config('quiz_submit_max', request_var('submit_max', 0));
					set_config('quiz_submit_max_multiple_choice', request_var('submit_max_multiple_choice', 0));
					set_config('quiz_save_enabled', request_var('saved_enabled', 0));
					set_config('quiz_play_once', request_var('quiz_play_once', 0));
					set_config('quiz_show_answers', request_var('show_answers', 0));
					set_config('quiz_time_limit_per_question', request_var('time_limit_per_question', 0));
					set_config('quiz_show_how_many_stats', request_var('how_many_stats', 0));
					set_config('quiz_user_edit_own_quiz', request_var('user_edit_own_quiz', 0));

					$cash_on_quiz = request_var('cash_on_quiz', 0);

					set_config('quiz_cash_on', $cash_on_quiz);

					if( $cash_on_quiz != 0 )
					{
						set_config('quiz_cash_win', request_var('quiz_cash_win', 0));
						set_config('quiz_cash_lose', request_var('quiz_cash_lose', 0));
					}

					trigger_error($user->lang['QUIZ_CONFIG_CHANGED_SUCESSFULLY'] . adm_back_link($this->u_action));
				}

	            $this->page_title = 'ACP_QUIZ';
	            $this->tpl_name = 'acp_quiz';
	
				$acl_url = '&amp;mode=index&sub=new_category';
				$new_category_link = append_sid("{$phpbb_admin_path}index.$phpEx", 'i=quiz' . $acl_url);
		
				// Quiz categories
				$sql = 'SELECT * FROM ' . QUIZ_CATEGORY_TABLE . '
						ORDER BY quiz_category_id ASC';
				$result = $db->sql_query($sql);
				
				while( $row = $db->sql_fetchrow($result) )
				{
					$number_of_quizzes = find_number_of_quiz_in_category($row['quiz_category_id']);

					$template->assign_block_vars('quiz_categories', array(
					'CATEGORY_NAME'			=> $row['quiz_category_name'],
					'CATEGORY_NUMBER_QUIZ'	=> ($number_of_quizzes == 1) ? sprintf($user->lang['NUMBER_OF_QUIZ_INDEX_SINGLE'], $number_of_quizzes) : sprintf($user->lang['NUMBER_OF_QUIZ_INDEX_PLURAL'], $number_of_quizzes),
					'CATEGORY_DESC'			=> $row['quiz_category_description'],
					'DELETE_LINK'			=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&sub=quiz_category_delete&c=' . $row['quiz_category_id']),
					'EDIT_LINK'				=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&sub=quiz_category&c=' . $row['quiz_category_id']),
					));
				}

				$template->assign_vars( array(
				'ADD_NEW_CATEGORY'	=> $new_category_link,
				'U_ACTION'	=> append_sid($phpbb_admin_path . 'index.'.$phpEx, 'i=quiz&amp;mode=index&type=submit'),
				'U_SUBMIT_MIN' => $config['quiz_submit_min'],
				'U_SUBMIT_MAX' => $config['quiz_submit_max'],
				'U_SUBMIT_MAX_MULTIPLE_CHOICE' => $config['quiz_submit_max_multiple_choice'],
				'U_SAVED_ENABLED' => $config['quiz_save_enabled'],
				'U_PLAY_ONCE' => $config['quiz_play_once'],
				'U_SHOW_ANSWERS' => $config['quiz_show_answers'],
				'U_TIME_LIMIT_PER_QUESTION' => $config['quiz_time_limit_per_question'],
				'U_HOW_MANY_STATS' => $config['quiz_show_how_many_stats'],
				'U_USER_EDIT_OWN_QUIZ' => $config['quiz_user_edit_own_quiz'],
				'U_QUIZ_CASH_ON' => $config['quiz_cash_on'],
				'U_QUIZ_CASH_WIN' => $config['quiz_cash_win'],
				'U_QUIZ_CASH_LOSE' => $config['quiz_cash_lose'],
				));
			}

            break;
      }
   }
} 
?>